Raphael.fn.barChart = function (posX, posY, w, h, values, labels, title) {
   
    var paper = this,
        chartH = h,
	  chartW = w,
	  chartX = posX,
        chartY = posY + h,
	  barGap = 5;
        chart = this.set();

     var txtTitle = paper.text(80, 15, title).attr({fill: "rgb(27,95,138)","font-family": 'Fontin-Sans, Arial', "font-size": "18px"});

	paper.rect(chartX, posY, 0.5, chartH);
	paper.rect(chartX, chartY, chartW, 0.5);
	
	var barW = (chartW - (barGap * values.length)) / values.length;
	var barH;  
	var x,y;
	var start = .05,
	   bcolor, color;

	var scaleMax = 0;
	for (var j=0; j<values.length; j++) {
		if(values[j] > scaleMax) {
			scaleMax = values[j];
		}
	}
    var scaleMaxOrig = scaleMax;
	var scaleInc = scaleMax / 10;
	scaleInc = Math.round(scaleInc/100)*100;
	scaleMax = scaleInc * 10;
	
	if (scaleMax==0){
		if (scaleMaxOrig < 100) {
			scaleMax=100;
		} else {
			scaleMax=500;
		}
	}
	
	process = function (i) {
		x=chartX + (i * (barW + barGap));
		barH = (values[i] * chartH) / scaleMax;	
		y=chartY-barH;
		bcolor = "hsb(" + start + ", 1, 1)";
	   	color = "hsb(" + start + ", 1, .5)";
	   	//alert("x:" + x + " y:" + y + " barW:" + barW + " barH:" + barH);
	   	var r = paper.rect(x, y, barW, barH).attr({gradient: "90-" + bcolor + "-" + color});
		var txt = paper.text(x+barW/2,y-5, values[i]);
		txt.attr("opacity", 0).attr({fill: bcolor, stroke: "none", opacity: 0, "font-family": 'Fontin-Sans, Arial', "font-size": "12px"});
		r.mouseover(function (event) {
		  
         r.animate({scale: [1.01, 1.01,x, y]}, 500, "elastic");
         txt.animate({opacity: 1}, 500, "elastic");
		}).mouseout(function (event) {
			r.animate({scale: [1, 1, x, y]}, 500, "elastic");
         txt.animate({opacity: 0}, 500);
		});
		var t = paper.text(x + (barW/2), chartY+20, labels[i]);
		t.rotate(55);
		start += 0.05;
	};
	
	for (var i=0; i<labels.length; i++) {
		
		process(i);
	}

	var scaleInc = scaleMax / 10;
	var scaleVal;

	for (var k=1; k<10; k++) {
		scaleVal = ((k*scaleInc) * chartH) / scaleMax;
		y = chartY-scaleVal;
		var scaleLabelMax = paper.text(chartX-15, y, Math.round(k*scaleInc)); 
		paper.rect(chartX-5, y, 10, 1);
		
	}
	
	
        return chart;
};
